function [I0 J0 valid] = findOptIter(E,A,S, trData)
sav = false; num=7;
if ~isfield(trData,'visu'), 
    visu = true; 
else
    visu = trData.visu;
end;
eps = trData.eps; [r c] = size(E); X0 = [1;1];

%%%%%% Find Targets %%%%%%%%%
Xt = [];
while length(Xt)==0,
for j=1:c,
    I = find(E(:,j)<eps);
    if length(I)>0,
    Xt = [Xt [I';repmat(j,1, length(I))]];
    end;
end;
eps = eps + 0.2;
end;

if length(Xt)>0,
%%%%%%% Find costs from each state to the nearest target %%%%%%%%%%%
E0 = Inf(r,c); pthI = zeros(r,c); pthJ = zeros(r,c); 
p = 0; p0 = 10; p1 = trData.iterBaseCompl;
for j = c:-1:1,    
for i = r:-1:1,
    if any(prod(double((Xt == repmat([i;j],1,size(Xt,2)))))),    % One of the targets
        p = 0;
    else
        if  i==1,
            p = E0(i+1,j) + p0;
        elseif i==r        
            if j+1<=c,   p = E0(1,j+1) + p1;
            else         p = p1; end;
        else
            p = E0(i+1,j) + p0; 
        end;
    end;
        if E0(i,j)>p,
            if i==r,
                E0(i,j) = p; pthI(i,j) = 1; pthJ(i,j) = j+1;
            else
                E0(i,j) = p; pthI(i,j) = i+1; pthJ(i,j) = j;
            end;
        end;

end;
p = p + p1;
[I] = find((1+trData.nextIterMargin)*E<A(j));%E(i,j));
J = E0(I)>p;
E0(I(J)) = p; pthI(I(J)) = i; pthJ(I(J)) = j;

end;
%hold on;
%%%%%%%% reconstruct path %%%%%%%%%%%%%%

if visu,
figure(1);
imagesc(A,S,E); colorbar; hold on;
plot(A(X0(2)), S(X0(1)),'bx', 'MarkerSize',10, 'LineWidth', 4);
plot(A(Xt(2,:)), S(Xt(1,:)),'ro', 'MarkerSize',10, 'LineWidth', 4); set(gca,'FontSize',16);
set(gca,'FontSize',16); xlabel('range'); ylabel('complexity');
end;

i = X0(1); j = X0(2); I = i; J = j; Q = A(1); Q0 = A(1); I0=[];J0=[]; valid = true; E_last=0;
while ~any(prod(double((Xt == repmat([i;j],1,size(Xt,2)))))),
    i0 = pthI(i,j); j0 = pthJ(i,j); i = i0; j = j0;
    I = [I i]; J = [J j]; Q = [Q E(i,j)];
    if ~(j==J(end-1)), 
        Q0 = [Q0 E( I(end-1),J(end-1))];  I0 = [I0 I(end-1)]; J0 = [J0 J(end-1)]; %valid = (valid)&&(A(J(end))>E_last);
        if visu, quiver(A(J(end-1)), S(I(end-1)),  A(J(end))- A(J(end-1)), S(I(end))-S(I(end-1)),0.95, 'k', 'LineWidth',3 ); end
    else
        if visu, quiver(A(J(end-1)), S(I(end-1)),  A(J(end))- A(J(end-1)), S(I(end))-S(I(end-1)),0.8, 'w', 'LineWidth',3 ); end;
    end;
    E_last = E(i,j); 
%    plot(A([J(end-1) J(end)]), S([I(end-1) I(end)]),'w', 'LineWidth',4 );

end; 
I0 = [I0 i]; J0 = [J0 j];
%axis([min(A) max(A) min(S) max(S)]);
Q0 = [Q0 E(i,j)];
%print('-depsc', ['dyn_progr_path',num2normstr(num, 3),'.eps']);
if sav, print('-depsc',['dp_path',num2normstr(num),'.eps']); end;

if visu,
figure(2); plot(0:(length(Q0)-1),Q0,'bo-','LineWidth',3,'MarkerSize',10); grid on; 
set(gca,'FontSize',16); xlabel('iter'); ylabel('uncertainty area size');
if sav, print('-depsc',['dp_iter',num2normstr(num),'.eps']); end;
figure(3);
imagesc(A,S,E0); colorbar; hold on; %pause
xlabel('range'); ylabel('complexity');
if sav, print('-depsc',['dp_cumsum',num2normstr(num),'.eps']); end;
end;

else
    valid = false;
    I0 = [];
    J0 = [];
end;

