function [model, valid] = getModel(im, X, R);

addpath rtcam
addpath siftDemoV4;

trData.nameModel = 'mouse_pad';
trData.imgModel = [trData.nameModel,'.jpg'];
trData.zm = 300;
trData.n_ex = 1;
trData.noise = 0.05;
trData.Z = [1];
trData.F = [0];
trData.N = 200;
trData.dN = round(100/5);    
trData.M = [R R];
trData.dM = round([R R]/20);
trData.Ranges = [R:round(-R/10):5];
trData.Complexities = [30:20:200];
trData.rndSamples = 1;
trData.sc = [];                   % scales
trData.blurDir = [];              % degrees
trData.blurSize = [];
trData.err_rel = false;
trData.pth = [];
trData.nextIterErr = 1;
trData.method = 'LP'; % 'LSQ', 'QP'
trData.visu = false;%true;
trData.numOfExamples = 1000;
trData.eps = 2.5;
trData.iterBaseCompl = 40;
 
close all;
[H,x_best,Err, X, valid] = trainH2(im, X, trData);

if valid, 
for j=1:size(x_best,1),          % for all points
    iter(j) = size(x_best(j,:),2);
    for k=1:size(x_best(j,:),2), % for all iterations
       h(j,k).h = H(j,k).h;
       x(j,k).x = x_best(j,k).x;
       if length(x_best(j,k).x)>0
           col(j,k).col =  im(sub2ind(size(im),x_best(j,k).x(2,:), x_best(j,k).x(1,:)));    
       elseif iter(j)==size(x_best(j,:),2), 
           iter(j) = k; 
       end;
    end;
end;
   
model.col = []; model.X = []; model.H = [];    
model.col = [model.col col]; model.X = [model.X x]; model.H = [model.H h];
model.Err = Err; model.C = X; model.iter = iter;
else
    model = [];
end; 

