function [H,x_best,Err, X, valid] = trainH2(im1,X, trData)

[r c] = size(im1); 
C = 0;
dispose = zeros(1,size(X,2));
for i=1:size(X,2),    % over all points    
        tic;   
          disp('generating training sets ...');
          [L,t,x] = genExamples7(im1, X(:,i), trData);       
        dt1 = toc;
      %  L_tst = L; t_tst = t;    
       % errHistSepSS; min(E95_10), min(E95_50)
        tic   
        Q = all(~isnan(L(1).L),2);
        if sum(Q)>trData.Complexities(end),
            disp('training monolitic predictors ...')
            [Emulti Hmulti Jmulti] = trainMultiplePredictors2(L,t, trData);
            disp('searching for an optimal sequence ...')
            [E0 H0 J0 ii jj valid] = findOptimalSequence(Emulti, Hmulti, Jmulti, trData);
            if valid,                
            for j=1:length(E0),
                Err(i,j,:) =  E0(j);
                H(i,j).h = H0(j).H;
                x_best(i,j).x = repmat(X(:,i),1,length(J0(j).J)) + x(jj(j)).x(:,J0(j).J); 
                C = C + size(H0(j).H,2);
            end;
            else
                dispose(i) = true;
            end;
         else
            dispose(i) = true;
            E0 = NaN;            
        end;               
        dt2 = toc;
        strE = ['[', sprintf('%3.1f ', E0), ']'];
        disp(sprintf('region:%d/%d, iter:%d, genTime:%3.2fs (%dx%d), trainTime:%3.2fs, Complexity:%d, E%d=%s',i, size(X,2),length(E0),dt1, sum(Q), size(L(1).L,2),dt2,C,round(100*trData.nextIterErr),  strE));    
end;

if ~exist('H','var'),
    H = []; x_best = []; Err = []; X = [];
else
    H = H(~dispose, :); x_best = x_best(~dispose,:); Err = Err(~dispose,:); X = X(:,~dispose);
end;

%hold on;
%plot(sum(patchErrTr,1)/size(patchErrTr,1),'c'); grid on;
%ylabel('MSE'); xlabel('translation')
%plot(patchErrTr); grid on;
