function [E H J X] = trainMultiplePredictors2(L,t, trData)
% Support set selection

for j=1:length(L),
    
Q = find(all(~isnan(L(j).L),2)); 
if strcmp(trData.supportSelection,'lsq'),
    rnd = genRnd(500,size(L(j).L,2)); L0 = L(j).L(:,rnd); L0 = L0(Q,:);
    I = selectSupportSet(L0, t(j).t(:,rnd), trData.Complexities(end)); %spravne bych se mel omezit jen na neNan!
else
    I = genRnd(trData.Complexities(end), length(Q));
end;

I = Q(I);
% for each range different support set is considered
for i=1:length(trData.Complexities),
    
   % L(j).L = L(j).L(:, genRnd(trData.numOfExamples, size(L(j).L,2));    
        if strcmp(trData.method,'lsq'),
            [H0 J0 E_trn L0 t0] = LSQrand2(L(j).L, t(j).t, trData, I(1:trData.Complexities(i)) );     
%            L_tst = L(1).L; t_tst = t(1).t;
            t_approx = H0(:,:)*L(j).L(J0,:);
            E0 = sqrt(sum((t(j).t(1:2,:) - t_approx(1:2,:)).^2));                
            EE = sort(E0); E95 = EE(round(trData.nextIterErr*length(EE)));
        elseif strcmp(trData.method, 'minmax'),
            % Outliers removal
      %      [H0 J0 E_trn L0 t0] = LSQrand2(L(j).L, t(j).t, trData, 5);%trData.Complexities(i));                
      %      E0 = sqrt(sum((t(j).t - H0*L(j).L(J0,:)).^2)); EE = sort(E0); E95 = EE(round(trData.nextIterErr*length(EE))); mean(E0);
      %      L0 = L(j).L(:,E0<=E95); 
      %      t0 = t(j).t(:,E0<=E95);            
            
            % minimax solution
           % [H0 J0 E_trn L1 t1 E95] = LPrand2(L0, t0, trData, trData.Complexities(i), I(1:trData.Complexities(i)));            
            [H0 J0 E_trn L1 t1 E95] = LPrand2(L(j).L, t(j).t, trData, I(1:trData.Complexities(i))); 
        else
            disp('Unknown learning method.')
        end;
        E(i,j) = max(E95); H(i,j).H = H0; J(i,j).J = J0; X(i,j).x = I(1:trData.Complexities(i));
        disp(sprintf('Built: C=%d (%d/%d), R=%1.3f (%d/%d), Err=%1.3f%%',trData.Complexities(i),i,length(trData.Complexities), trData.Ranges(j), j,length(trData.Ranges), sqrt(sum(E95.^2))));
    end;    
end;