% NOTES:
% 
% Just run to see tracking.
%
% This script uses learned model to track the point in a testing sequence. Only linTrack function is used for tracking, the rest containts
% visualisation and I/O things. If you need the function linTrack could be easily re-implemented or changed.

addpath codes
close all
load leguan

% I/O options:
options.sequence = 'data/';%/datagrid/MultiCam/zimmerk/leguan/';
options.firstFrame = 1;
options.stepFrame = 1;
options.lastFrame = 70;
% tracking options:
options.firstIter = 1;                          % first used predictor in the sequence (first iteration)
options.iter = length(model.X);                 % number of iterations (default value correspond to the number of learned iterations)

d = dir(options.sequence);
I = find(~[d(:).isdir]); p =zeros(2,1); XX = [];

for i=I(options.firstFrame:options.stepFrame:options.lastFrame),
    im = double(rgb2gray(imread([options.sequence, d(i).name])))/255;
    [p out]= linTrack(im, p, model, options); 
    if ~out, 
        p = zeros(2,1);
    end;
%% visualisation
    XX = [XX p(1:2)];
    clf; imshow(im); title(i); hold on;  plot(model.C(1)+XX(1,:),model.C(2)+XX(2,:),'-'); plot(model.C(1)+XX(1,:),model.C(2)+XX(2,:),'ro'); hold on
    plot(model.C(1)+p(1),model.C(2)+p(2), 'rx','MarkerSize',10,'LineWidth',4); drawnow;    
end;

